vRP = Proxy.getInterface("vRP")
vRPbanca = Tunnel.getInterface("vrp_banking", "vrp_banking")

local deschis = false;
local dict = 'anim@amb@prop_human_atm@interior@male@enter'
local anim = 'enter'

local function openBanca()
    vRPbanca.fetchPlayerAccount({}, function(data)
        SendNUIMessage{
            action = 'deschideBanca',
            bani = tonumber(data.cash),
            cont = tonumber(data.banca),
            numeJucator = tostring(data.jucator),
        }
        TriggerScreenblurFadeIn(150)
        SetNuiFocus(true, true)
    end)
end

RegisterNUICallback('updateSume', function()
    vRPbanca.fetchPlayerAccount({}, function(data)
        SendNUIMessage{
            action = 'updateSume',
            bani = tonumber(data.cash),
            cont = tonumber(data.banca),
        }
    end)
end)

RegisterNUICallback('iesire', function()
    SetNuiFocus(false, false)
    TriggerScreenblurFadeOut(150)
    deschis = false;
end)

RegisterNUICallback('transferaBani', function(data)
    local IBAN = tonumber(data.destinatar);
    local suma = tonumber(data.suma);
    vRPbanca.transferaBani({IBAN, suma})
end)

RegisterNUICallback('depunereBani', function(data)
    local suma = tonumber(data.suma);
    if suma > 0 then
        vRPbanca.depoziteazaBani({suma})
    end
end)

RegisterNUICallback('retrageBani', function(data)
    local suma = tonumber(data.suma);
    vRPbanca.retrageBani({suma})
end)

-- // BLIPS + THREAD LOCATIE

local banci = {
	{blip = 108, blipColor = 2, blipScale = 0.6, x = 150.266, y = -1040.203, z = 29.374, blipText = "Banca"},
	{blip = 108, blipColor = 2, blipScale = 0.6, x = -1212.980, y = -330.841, z = 37.787, blipText = "Banca"},
	{blip = 108, blipColor = 2, blipScale = 0.6, x = -2962.582, y = 482.627, z = 15.703, blipText = "Banca"},
	{blip = 108, blipColor = 2, blipScale = 0.6, x = -112.202, y = 6469.295, z = 31.626, blipText = "Banca"},
	{blip = 108, blipColor = 2, blipScale = 0.6, x = 314.187, y = -278.621, z = 54.170, blipText = "Banca"},
	{blip = 108, blipColor = 2, blipScale = 0.6, x = -351.534, y = -49.529, z = 49.042, blipText = "Banca"},
	{blip = 108, blipColor = 2, blipScale = 0.6, x = 246.49337768554, y = 223.59375, z = 106.28676605224, blipText = "Banca"},
	{blip = 108, blipColor = 2, blipScale = 0.6, x = 1175.064, y = 2706.643, z = 38.094, blipText = "Banca"},
}

local modeleATM = {
	{model = -870868698},
	{model = -1126237515},
	{model = -1364697528},
	{model = 506770882},
}

function LoadAnimation(dict)
	RequestAnimDict(dict)
	while not HasAnimDictLoaded(dict) do
		Citizen.Wait(1)
	end
end

function NearBank()
    local pos = GetEntityCoords(PlayerPedId())

    for k, v in pairs(banci) do
        local dist = #(vector3(v.x, v.y, v.z) - vector3(pos.x, pos.y, pos.z))

        if dist <= 3 then
            return true
        elseif dist <= 3 + 5 then
            return "update"
        end
    end
end

function NearATM()
    local ped = PlayerPedId()
    local pos = GetEntityCoords(ped)

    for i = 1, #modeleATM do
        local atm = GetClosestObjectOfType(pos.x, pos.y, pos.z, 1.5 + 5, modeleATM[i].model, false, false, false)
        if DoesEntityExist(atm) then
            if atm ~= closestATM then
                closestATM = atm
                atmPos = GetEntityCoords(atm)
            end
            local dist = #(vector3(pos.x, pos.y, pos.z) - vector3(atmPos.x, atmPos.y, atmPos.z))

            if dist <= 1.5 then
                return true
            elseif dist <= 1.5 + 5 then
                return "update"
            end
        end
    end
end

function ShowHelpNotification(msg, thisFrame, beep, duration)
    AddTextEntry('bankNotif', msg)

    if thisFrame then
        DisplayHelpTextThisFrame('bankNotif', false)
    else
        if beep == nil then beep = true end
        BeginTextCommandDisplayHelp('bankNotif')
        EndTextCommandDisplayHelp(0, false, beep, duration or - 1)
    end
end


CreateThread(function()
    local tempBlip = {}
    for keyblip, datablip in pairs(banci) do
        tempBlip[keyblip] = AddBlipForCoord(datablip.x, datablip.y, datablip.z)
        SetBlipSprite(tempBlip[keyblip], datablip.blip)
        SetBlipColour(tempBlip[keyblip], datablip.blipColor)
        SetBlipScale(tempBlip[keyblip], datablip.blipScale)
        SetBlipAsShortRange(tempBlip[keyblip], true)
        BeginTextCommandSetBlipName("STRING")
        AddTextComponentString(datablip.blipText)
        EndTextCommandSetBlipName(tempBlip[keyblip])
    end

    while true do
        Wait(0)
        if NearATM() and not deschis and NearATM() ~= "update" then
            ShowHelpNotification("Apasa ~INPUT_PICKUP~ pentru a accesa ~r~ATM")

            if IsControlJustReleased(0, 51) then
                if not deschis then
                    deschis = true
                    LoadAnimation(dict)
                    TaskPlayAnim(PlayerPedId(), dict, anim, 8.0, 8.0, -1, 0, 0, 0, 0, 0)
                    Citizen.Wait(2 * 1000)
                    ClearPedTasks(PlayerPedId())

                    openBanca()
                end
            end
        elseif NearATM() == "update" then
            Citizen.Wait(100)
        else
            Citizen.Wait(1000)
        end
    end
end)

CreateThread(function()
    while true do
        Wait(0)
        if NearBank() and not isBankOpened and NearBank() ~= "update" then
            ShowHelpNotification("Apasa ~INPUT_PICKUP~ pentru a accesa ~r~Banca")

            if IsControlJustReleased(0, 51) then
                RequestAnimDict(dict)
                if not deschis then
                    deschis = true
                    LoadAnimation(dict)
                    TaskPlayAnim(PlayerPedId(), dict, anim, 8.0, 8.0, -1, 0, 0, 0, 0, 0)
                    Citizen.Wait(2 * 1000)
                    ClearPedTasks(PlayerPedId())

                    openBanca()
                end
            end
        elseif NearBank() == "update" then
            Citizen.Wait(300)
        else
            Citizen.Wait(1000)
        end
    end
end)